//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers    1 
#property indicator_color1     DimGray
#property indicator_width1     2
#property indicator_level1  0.0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int RepulseLength  = 5;

//
//
//
//
//

double buffa[];
double buffb[];
double repulse[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0, repulse); 
   SetIndexBuffer(1, buffa); 
   SetIndexBuffer(2, buffb); 
   return(0);
}
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+RepulseLength);
   for(i=limit; i>=0; i--)
   {
      double pricea = 100*(3.0*Close[i]-2.0*Low[i]-Open[i])/Close[i];
      double priceb = 100*(Open[i]+2.0*High[i]-3.0*Close[i])/Close[i];
      if (i==Bars-1)
      {
         buffa[i] = pricea;
         buffb[i] = priceb;
         continue;
      }
      buffa[i] = buffa[i+1]+alpha*(pricea-buffa[i+1]);
      buffb[i] = buffb[i+1]+alpha*(priceb-buffb[i+1]);
      repulse[i] = buffa[i]-buffb[i];
   }
   return(0);
}